SystemOrganization addCategory: #KinematicTemplates!

SystemWindow subclass: #KinematicWindow
	instanceVariableNames: 'virtualCursor templates drawnPath lastDrawnPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

!KinematicWindow class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:56'!
openExample
	| w|
	w := self new.
	w openAsIs.

		
	! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:57'!
initialize
	super initialize.
	self setLabel:'Kinematic Templates'.
	self width: 1000.
	self height: 700.
	self addMorph: (KinematicCanvas new position: 0@50; width: self width; height: self height - 40; color: Color white).! !

RectangleMorph subclass: #KinematicCanvas
	instanceVariableNames: 'virtualCursor templates drawnPath lastDrawnPoint previousRealMousePosition handMorph currentRealMousePosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:42'!
addTemplate: aTemplate
	templates add: aTemplate! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 00:49'!
applyTemplates: realDelta
	| selectedTemplates cursorPosition temp |
	selectedTemplates := templates select: [ :aTemplate | aTemplate containsPoint: currentRealMousePosition  ].
	^selectedTemplates inject: realDelta into: [ :transformation :aTemplate | 
		aTemplate transformedDelta: transformation for: lastDrawnPoint ]
	! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 21:04'!
handleMouseMove: anEvent
	virtualCursor position: anEvent cursorPoint.
	super handleMouseMove: anEvent
! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:41'!
handlesMouseDown: anEvent
	^true! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'GermanLeiva 12/13/2012 20:41'!
handlesMouseOver: evt
	^true! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 00:31'!
initialize
	| tpl1 tpl2 |
	super initialize.
	
	templates := OrderedCollection new.

	virtualCursor := RectangleMorph new width: 10; height: 10; color: Color red.
	
	tpl1 := StraightLineTemplate new height: 300; width: 300.
	self addMorphBack: tpl1.
	self addTemplate: tpl1. 
	
	tpl2 := CompassTemplate new height: 400; width: 400; left: tpl1 width.
	tpl2 color: Color red.
	self addMorphBack: tpl2.
	self addTemplate: tpl2.

	self addMorph: virtualCursor.
	
	handMorph:=(CircleMorph new width: 15; height: 15).
	 self addMorph:  handMorph.! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 01:00'!
mouseDown: event
	Transcript show: '>> mouseDown: ' ; cr.
	super mouseDown: event.

	lastDrawnPoint := event cursorPoint.
	drawnPath  := LineMorph from: lastDrawnPoint to: lastDrawnPoint color: Color black width: 2.
	self addMorph: drawnPath.! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:59'!
mouseEnter: event
	Transcript show: '>> mouseEnter: '; cr.
	super mouseEnter: event.
	self addMorph: virtualCursor.
	self currentHand showTemporaryCursor: Cursor blank.! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:58'!
mouseLeave: event
	Transcript show: '>> mouseLeave: '; cr.
	super mouseLeave: event.
	self currentHand showTemporaryCursor: nil.
	virtualCursor delete.
	drawnPath := nil.
	lastDrawnPoint := nil.! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 02:43'!
mouseMove: event
	| realDelta delta |
	
	Transcript show: '>> mouseMove: '; cr.
	previousRealMousePosition ifNil: [ previousRealMousePosition := event startPoint ].	
	currentRealMousePosition ifNil: [ currentRealMousePosition := event endPoint ] ifNotNil:[ currentRealMousePosition := previousRealMousePosition  + (event endPoint - event startPoint )].
	
"	realDelta := currentRealMousePosition - previousRealMousePosition."
	realDelta := event endPoint -  previousRealMousePosition .
	
	Transcript show: 'current real: ', currentRealMousePosition  asString; cr.
	Transcript show: 'previous real:: ', previousRealMousePosition  asString; cr.
	Transcript show: 'realDelta: ', realDelta asString; cr.
	Transcript show: 'mouse move delta:  ', (event endPoint - event startPoint  ) asString; cr.
	
	delta := self applyTemplates: realDelta.
	
	drawnPath setVertices: (drawnPath vertices copyWith: lastDrawnPoint + delta).
		
	virtualCursor position: lastDrawnPoint + delta. 
		
	lastDrawnPoint := lastDrawnPoint + delta.

 	self activeHand showTemporaryCursor: Cursor webLink  hotSpotOffset:  (self activeHand position -  virtualCursor position) .
"	self activeHand position: virtualCursor position ."
	
	
	handMorph position: self activeHand position.
	previousRealMousePosition := event endPoint  .

! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 00:40'!
mouseUp: event
	Transcript show: '>> mouseUp: '; cr.
	currentRealMousePosition := previousRealMousePosition := nil.
	drawnPath := nil.
	lastDrawnPoint := nil.! !

RectangleMorph subclass: #KinematicTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicTemplate subclass: #CompassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 01:47'!
transformedDelta: realDelta for: lastDrawnPoint
	| shiftPoint origR origTheta newR newTheta finalR finalTheta |
	
	shiftPoint := lastDrawnPoint - self center.
	
	origR := shiftPoint r.
	origTheta := shiftPoint theta.
	
	newR := (shiftPoint + realDelta) r.
	newTheta := (shiftPoint + realDelta) theta.
	
	finalR := (newR - origR) * 0.1 + origR.
  	finalTheta := (newTheta - origTheta) + origTheta.
	
	^Point 
		x: finalR * finalTheta cos - shiftPoint x
		y: finalR * finalTheta sin - shiftPoint y.! !

!KinematicTemplate class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 09:47'!
openExample
	|w tpl|
	w := SystemWindow new setLabel:'Kinematic Templates'.
	tpl := self new height: 300; width: 300; top: 30.
	w addMorph: tpl.
	w openInWorld.! !

KinematicTemplate subclass: #StraightLineTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!StraightLineTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/13/2012 20:16'!
transformedDelta: realDelta for: lastDrawnPoint
	^ (realDelta x * 1) @ (realDelta y * 0.1)! !
